import urllib2
import simplejson as json
import pickle
import socket
host=socket.gethostname()
port=6785
site='http://'+host
site+=':'+str(port)
print 'testing on site : '+site
print '=====testing serviceMap====='
url = '/'.join([site,'serviceMap'])
try:
  response=urllib2.urlopen(urllib2.Request(url))
  print json.loads(response.read())
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"


print '=====testing getAllTags====='
url = '/'.join([site,'iov','getTags'])
url += '?det=LUMINOSITY&service=cms_orcoff_prod&schema=CMS_COND_31X_RUN_INFO'
print 'query: ',url
taglist=[]
try:
  response=urllib2.urlopen(urllib2.Request(url))
  result=json.loads(response.read())
  if result['status']!='OK':
     print 'Application Error: ', result['status']
  else:
     print 'returned data: ',result['data']
     taglist=result['data'].split(' ')
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"
    
print '=====testing getAllTags from frontier====='
url = '/'.join([site,'iov','getTags'])
url += '?det=LUMINOSITY&service=cms_orcoff_prod&schema=CMS_COND_31X_RUN_INFO&viacache=1'
print 'query: ',url
taglist=[]
try:
  response=urllib2.urlopen(urllib2.Request(url))
  result=json.loads(response.read())
  if result['status']!='OK':
     print 'Application Error: ', result['status']
  else:
     print 'returned data: ',result['data']
     taglist=result['data'].split(' ')
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"

print '=====testing getIOVForTag for 1st tag found ===== ',taglist[0]
url = '/'.join([site,'iov','getIOVForTag'])
url += '?det=Luminosity&service=cms_orcoff_prod&schema=CMS_COND_31X_RUN_INFO&tag='+taglist[0]
print 'query: ',url
try:
  response=urllib2.urlopen(urllib2.Request(url))
  result=json.loads(response.read())
  if result['status']!='OK':
     print 'Application Error: ', result['status']
  else:
     print 'returned data: ',result
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"

print '=====testing getPayloadSummariesForTag for 2nd tag found ===== ',taglist[1]
url = '/'.join([site,'iov','getPayloadSummariesForTag'])
url += '?det=Luminosity&service=cms_orcoff_prod&schema=CMS_COND_31X_RUN_INFO&tag='+taglist[1]
print 'query: ',url
try:
  response=urllib2.urlopen(urllib2.Request(url))
  result=json.loads(response.read())
  if result['status']!='OK':
     print 'Application Error: ', result['status']
  else:
     print 'returned data: ',result['data']
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"

print '=====testing getTrendForTag for 2nd tag found ===== ',taglist[1]
url = '/'.join([site,'iov','getTrendForTag'])
url += '?det=Luminosity&service=cms_orcoff_prod&schema=CMS_COND_31X_RUN_INFO&tag='+taglist[1]
print 'query: ',url
from CondCore.Utilities import timeUnitHelper
try:
  response=urllib2.urlopen(urllib2.Request(url))
  result=json.loads(response.read())
  if result['status']!='OK':
     print 'Application Error: ', result['status']
  else:
     #print 'returned data: ',result['data']
     mytrend=result['data']
     lumidata=[]
     for block in mytrend:
       sinceLumiTuple=timeUnitHelper.unpackLumiid(block[0])
       tillLumiTuple=timeUnitHelper.unpackLumiid(block[1])
       lumiavg=block[2][0]
       lumidata.append((sinceLumiTuple,tillLumiTuple,lumiavg))
     print json.dumps(lumidata)
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"

print '=====testing luminosityApp ===== '
url = '/'.join([site,'lumi','allLumiTags'])
url += ''
print 'query: ',url
from CondCore.Utilities import timeUnitHelper
try:
  response=urllib2.urlopen(urllib2.Request(url))
  result=json.loads(response.read())
  print result
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"

print '=====testing luminosityTrend ===== '
url = '/'.join([site,'lumi','LumiSummaries'])
url += '?account=oracle://cms_orcoff_prod/CMS_COND_31X_RUN_INFO&tag='
url +='lumi83037_v1_iovFrom1'
print 'query: ',url
from CondCore.Utilities import timeUnitHelper
try:
  response=urllib2.urlopen(urllib2.Request(url))
  result=pickle.loads(response.read())
  print result
except IOError,e:
  if hasattr(e,'code'):
    print 'The server couldn\'t fulfill the request'
    print 'Error code: ',e.code
  elif hasattr(e,'reason'):
    print 'failed to reach a server '
    print 'Reason: ',e.reason
  else:
    print "know not"

